using System;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Interactivity;

namespace SpiderWebDemo
{
	public class AddSpiderItemAction : TriggerAction<FrameworkElement>
	{
		private static Random _random = new Random();

		protected override void Invoke(object parameter)
		{
			var vm = AssociatedObject.DataContext as NodeViewModel;
			if (vm != null)
			{
				if (vm.Children == null)
				{
					vm.Children = new ObservableCollection<NodeViewModel>();
				}
				var child = new NodeViewModel
				            	{
				            		Title = "New-" + _random.NextDouble(),
									Parent = vm
				            	};
				vm.Children.Add(child);
			}
		}
	}
}